var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
var FileSpec = Components.classes["@mozilla.org/filespec;1"].createInstance(Components.interfaces.nsIFileSpec);
var IOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
var FileProtocolHandler = IOService.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
var nsIRDFResource = Components.interfaces.nsIRDFResource;
var nsIRDFLiteral = Components.interfaces.nsIRDFLiteral;

function AccountImport() {
  filePicker.init(window, strbundle.getString("OpenFile"), nsIFilePicker.modeOpen);
  filePicker.appendFilter(strbundle.getString("AccountFile") + " (*.rdf)","*.rdf;");

  if(filePicker.show() == nsIFilePicker.returnOK) {
    var datasource = RDFService.GetDataSourceBlocking(FileProtocolHandler.getURLSpecFromFile(filePicker.file));
    var NClength = NC.length;
    
    /*****************************************************************************************************
    * allgemeine einstellungen in objGlobal speichern
    ******************************************************************************************************/
    objGlobal = new Object;

    var rdfGlobal = RDFService.GetResource("http://accountex/global");
    var arcs = datasource.ArcLabelsOut(rdfGlobal);

	  if (!arcs.hasMoreElements()) {
	    alert(strbundle.getString("0002"));
	  } else {

      while (arcs.hasMoreElements()) {
        var arc = arcs.getNext().QueryInterface(nsIRDFResource);
        var arcName = arc.Value;
        arcName = arcName.substring(NClength, arcName.length);
        objGlobal[arcName] = datasource.GetTarget(rdfGlobal, arc, true).QueryInterface(nsIRDFLiteral).Value;
      }

      switch (objGlobal.type) {
      case "none":
        /*****************************************************************************************************
        * prfen ob ein Lokaler Ordner bereits vorhabden ist
        ******************************************************************************************************/
        var localServer = null;
        try {
          localServer = accountManager.localFoldersServer;
        }
        catch (ex) {
          localServer = null;
        }

        if (localServer != null) {
        var result = promptService.confirmEx(window, strbundle.getString("TitleImport"), strbundle.getString("0001"), (promptService.BUTTON_TITLE_IS_STRING*promptService.BUTTON_POS_0)+(promptService.BUTTON_TITLE_IS_STRING*promptService.BUTTON_POS_1),strbundle.getString("WizardContinue"),strbundle.getString("WizardExit"), null, null, {value:0});
          if (result == 1) {
            break;
          }  
        }

        /*****************************************************************************************************
        * server einstellungen in objServer speichern
        ******************************************************************************************************/
        objServer = new Object;
      
        var rdfServer = RDFService.GetResource("http://accountex/server");
        var arcs = datasource.ArcLabelsOut(rdfServer);

        while (arcs.hasMoreElements()) {
          var arc = arcs.getNext().QueryInterface(nsIRDFResource);
          var arcName = arc.Value;
          arcName = arcName.substring(NClength, arcName.length);
          objServer[arcName] = datasource.GetTarget(rdfServer, arc, true).QueryInterface(nsIRDFLiteral).Value;
        }


        if (CheckLocalPath() == true) {
          if (localServer == null) {
          var server = accountManager.createIncomingServer("nobody","Local Folders","none");
          } else {
            var server = accountManager.localFoldersServer
          }
        
          FileSpec.unicodePath = objServer.localPath;
          server.localPath = FileSpec;
          server.emptyTrashOnExit = objServer.emptyTrashOnExit;

          server.prettyName = objServer.prettyName;

          /*****************************************************************************************************
          * Lokalen Account erstellen
          ******************************************************************************************************/      
          var account = accountManager.createAccount();
          account.incomingServer = server;
        
          AccountImportFinish();
        }
        break;
      case "pop3":
        /*****************************************************************************************************
        * Daten einlesen
        ******************************************************************************************************/
        objServer = new Object;
      
        var rdfServer = RDFService.GetResource("http://accountex/server");
        var arcs = datasource.ArcLabelsOut(rdfServer);

        while (arcs.hasMoreElements()) {
          var arc = arcs.getNext().QueryInterface(nsIRDFResource);
          var arcName = arc.Value;
          arcName = arcName.substring(NClength, arcName.length);
          objServer[arcName] = datasource.GetTarget(rdfServer, arc, true).QueryInterface(nsIRDFLiteral).Value;
        }
        
        objPop3 = new Object;
      
        var rdfPop3 = RDFService.GetResource("http://accountex/pop3");
        var arcs = datasource.ArcLabelsOut(rdfPop3);

        while (arcs.hasMoreElements()) {
          var arc = arcs.getNext().QueryInterface(nsIRDFResource);
          var arcName = arc.Value;
          arcName = arcName.substring(NClength, arcName.length);
          objPop3[arcName] = datasource.GetTarget(rdfPop3, arc, true).QueryInterface(nsIRDFLiteral).Value;
        }

        /*****************************************************************************************************
        * prfen ob der Account schon existiert
        ******************************************************************************************************/
        if (AccountExists(objServer.username,objServer.hostName,objGlobal.type)) {
          alert(strbundle.getString("0004"));
          break;
        };

        /*****************************************************************************************************
        * prfen wo deferredToAccount hingeht
        ******************************************************************************************************/

        if (objPop3.deferredToAccount == 1) {
          if (AccountNameExists(objPop3.deferredToAccountName) == false) {
            var result = promptService.confirmEx(window,strbundle.getString("TitleImport"), strbundle.getString("0005"), promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 + promptService.BUTTON_TITLE_CANCEL * promptService.BUTTON_POS_1 + promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_2, strbundle.getString("Wizard01"), null, strbundle.getString("Wizard02"), null, {value:0});
            switch (result) {
              case 0:
                //Separater Posteingang
                var tmpDefferedAccount = "";
                break;
              case 1:
                //Abbruch
                break;
              case 2:
                //Lokaler Ordner
                if (CheckLocalFolder()) {
                  var localFoldersServer = accountManager.localFoldersServer;
                  var localFoldersAccount = accountManager.FindAccountForServer(localFoldersServer);
                  var tmpDefferedAccount = localFoldersAccount.key;
                  break;
                }
            }
          } else {
           var tmpDefferedAccount = GetNameAccount(objPop3.deferredToAccountName); 
          }
        }


        /*****************************************************************************************************
        * prfen ob ein Lokaler Ordner bereits vorhabden ist
        ******************************************************************************************************/
        CheckLocalFolder();
 
        var server = accountManager.createIncomingServer(objServer.username,objServer.hostName,objGlobal.type);
        var pop3 = server.QueryInterface(Components.interfaces.nsIPop3IncomingServer);
        var identity = accountManager.createIdentity();



              pop3.deferredToAccount = tmpDefferedAccount;
 
              pop3.headersOnly = Number(objPop3.headersOnly);
              pop3.leaveMessagesOnServer = Number(objPop3.leaveMessagesOnServer);
              pop3.deleteByAgeFromServer = Number(objPop3.deleteByAgeFromServer);
              pop3.numDaysToLeaveOnServer = objPop3.numDaysToLeaveOnServer;
              pop3.deleteMailLeftOnServer = Number(objPop3.deleteMailLeftOnServer);
              pop3.deferGetNewMail = Number(objPop3.deferGetNewMail);

              server.port = objServer.port;
              server.isSecure = Number(objServer.isSecure);
              server.useSecAuth = Number(objServer.useSecAuth);
              server.loginAtStartUp = Number(objServer.loginAtStartUp);
              server.biffMinutes = objServer.biffMinutes;
              server.downloadOnBiff = Number(objServer.downloadOnBiff);
              server.emptyTrashOnExit = Number(objServer.emptyTrashOnExit);      
              FileSpec.unicodePath = objServer.localPath;
              server.localPath = FileSpec;
              server.prettyName = objServer.prettyName;

              var account = accountManager.createAccount();


              for (var i = 0; i < objGlobal.identities; i++) {
                var identity = accountManager.createIdentity();
                

                objIdentity = new Object;
              
                var rdfIdentity = RDFService.GetResource("http://accountex/identity" + i);
                var arcs = datasource.ArcLabelsOut(rdfIdentity);
        
                while (arcs.hasMoreElements()) {
                  var arc = arcs.getNext().QueryInterface(nsIRDFResource);
                  var arcName = arc.Value;
                  arcName = arcName.substring(NClength, arcName.length);
                  objIdentity[arcName] = datasource.GetTarget(rdfIdentity, arc, true).QueryInterface(nsIRDFLiteral).Value;

                  identity[arcName] = objIdentity[arcName];
                }                
                
                account.addIdentity(identity);


              }

              server.valid = false;
              account.incomingServer = server;
              server.valid = true;
            
          if (CheckLocalPath() == true) {
            AccountImportFinish();
//          }
        break;
        }
      }
    }
  }
}

function CheckLocalPath() {
  if (objGlobal.os != OS()) {
    ServerPath.value = objServer.localPath
    deck.setAttribute("selectedIndex", "3");
    forwardButton.setAttribute("disabled", true);
    return true;
  } else {
    return true;
  }
}

function AccountImportFinish() {
	        /*****************************************************************************************************
        * "Local Folders" erstellen
        ******************************************************************************************************/ 
//        var localServer = null;
//        try {
//          localServer = accountManager.localFoldersServer;
//        }
//        catch (ex) {
//          localServer = null;
//        }



  /*****************************************************************************************************
  * Dialog abschlieen
  ******************************************************************************************************/
    deck.setAttribute("selectedIndex", "4");
    var finishFile = document.getElementById("finishFile");
    finishFile.value = filePicker.file.path;
    backButton.setAttribute("disabled", true); 
    forwardButton.label = forwardButton.getAttribute("finishedval");
    forwardButton.setAttribute("dlgtype", "finish");
    cancelButton.setAttribute("disabled", true);  
    checkImportFinish = document.getElementById("checkExportFinish");
    checkImportFinish.checked = false;
       
}

function AccountNameExists(AccountName)
/*****************************************************************************************************
* Prfen ob der per Name bergebene Account existiert
******************************************************************************************************/
{
  var defferedAccountExists = false;
  
  var originalAccounts = PrefValue("mail.accountmanager.accounts");
  if (originalAccounts) {
    var accounts = originalAccounts.split(",");
    var accountCount = accounts.length;
      for (var i = 0; i < accountCount; i++) {
        var accountTMP = accountManager.getAccount(accounts[i]);
        var serverTMP = accountTMP.incomingServer;
        if (serverTMP.prettyName == AccountName)
        {
           defferedAccountExists = true;
           break;
        }
      }
  }
  return defferedAccountExists;
}

function GetNameAccount(AccountName)
/*****************************************************************************************************
* Account.key anhand des PrettyName herausfinden
******************************************************************************************************/
{
  var getNameAccount = "";
  
  var originalAccounts = PrefValue("mail.accountmanager.accounts");
  if (originalAccounts) {
    var accounts = originalAccounts.split(",");
    var accountCount = accounts.length;
      for (var i = 0; i < accountCount; i++) {
        var accountTMP = accountManager.getAccount(accounts[i]);
        var serverTMP = accountTMP.incomingServer;
        if (serverTMP.prettyName == AccountName)
        {
           getNameAccount = accountTMP.key;
           break;
        }
      }
  }
  return getNameAccount;
}

function CheckLocalFolder()
 /*****************************************************************************************************
* prfen ob ein Lokaler Ordner bereits vorhabden ist
******************************************************************************************************/
{
  var localFoldersServer = false;

  try {
    localFoldersServer = accountManager.localFoldersServer;
  }
  catch (ex) {
    localFoldersServer = false;
  }

  if (localFoldersServer == false) {
  var result = promptService.confirmEx(window, strbundle.getString("TitleImport"), strbundle.getString("0003"), (promptService.BUTTON_TITLE_IS_STRING*promptService.BUTTON_POS_0)+(promptService.BUTTON_TITLE_IS_STRING*promptService.BUTTON_POS_1),strbundle.getString("WizardContinue"),strbundle.getString("WizardExit"), null, null, {value:0});
    if (result == 1) {
      localFoldersServer = false;
    } else {
      // Lokalen Ordner erstellen
      messengerMigrator = Components.classes["@mozilla.org/messenger/migrator;1"].getService(Components.interfaces.nsIMessengerMigrator);
      messengerMigrator.createLocalMailAccount(false /* false, since we are not migrating */);
      localFoldersServer = true;
    }
  } 

  return localFoldersServer;
}